//+----------------------------------------------------------------------------+
//|                                                             i-StochMA.mq4  |
//|                                                                            |
//|              : http://www.onix-trade.net/forum/index.php?showtopic=8269|
//|  :   . aka KimIV,  http://www.kimiv.ru            |
//|                                                                            |
//|  08.09.2008                               |
//|                     .           |
//+----------------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 LightBlue
#property indicator_color2 Salmon
#property indicator_width1 0
#property indicator_width2 0

//-------    ----------------------------------------+
extern int NumberOfBars = 1000;        //    (0-)
extern int KPeriod     = 5;  //  ( )    %K.
extern int DPeriod     = 3;  //      %D.
extern int Slowing     = 3;  //  .
extern int Method      = 1;  //  :
                             //  0 - MODE_SMA -   
                             //  1 - MODE_EMA -   
                             //  2 - MODE_SMMA -   
                             //  3 - MODE_LWMA - -  
extern int Price_Field = 0;  //     :
                             //  0 - Low/High
                             //  1 - Close/Close
extern int MA1.Period = 34;  //      .
extern int MA1.Method = 1;   //  :
                             //  0 - MODE_SMA -   
                             //  1 - MODE_EMA -   
                             //  2 - MODE_SMMA -   
                             //  3 - MODE_LWMA - -  
extern int MA1.APrice = 0;   //  :
                             //  0 - PRICE_CLOSE -  
                             //  1 - PRICE_OPEN -  
                             //  2 - PRICE_HIGH -  
                             //  3 - PRICE_LOW -  
                             //  4 - PRICE_MEDIAN -  , (high+low)/2
                             //  5 - PRICE_TYPICAL -  , (high+low+close)/3
                             //  6 - PRICE_WEIGHTED -   , (high+low+close+close)/4
extern int MA2.Period = 13;  //      .
extern int MA2.Method = 1;   //  :
                             //  0 - MODE_SMA -   
                             //  1 - MODE_EMA -   
                             //  2 - MODE_SMMA -   
                             //  3 - MODE_LWMA - -  
extern int MA2.APrice = 0;   //  :
                             //  0 - PRICE_CLOSE -  
                             //  1 - PRICE_OPEN -  
                             //  2 - PRICE_HIGH -  
                             //  3 - PRICE_LOW -  
                             //  4 - PRICE_MEDIAN -  , (high+low)/2
                             //  5 - PRICE_TYPICAL -  , (high+low+close)/3
                             //  6 - PRICE_WEIGHTED -   , (high+low+close+close)/4

//-------   -----------------------------------------------+

//-------   ---------------------------------------------------+
double dBuf0[], dBuf1[];

//-------    ------------------------------------------+


//+----------------------------------------------------------------------------+
//|  Custom indicator initialization function                                  |
//+----------------------------------------------------------------------------+
void init() {
  SetIndexArrow     (0, 233);
  SetIndexBuffer    (0, dBuf0);
  SetIndexEmptyValue(0, EMPTY_VALUE);
  SetIndexStyle     (0, DRAW_ARROW);

  SetIndexArrow     (1, 234);
  SetIndexBuffer    (1, dBuf1);
  SetIndexEmptyValue(1, EMPTY_VALUE);
  SetIndexStyle     (1, DRAW_ARROW);

  Comment("");
}

//+----------------------------------------------------------------------------+
//|  Custom indicator deinitialization function                                |
//+----------------------------------------------------------------------------+
void deinit() { Comment(""); }

//+----------------------------------------------------------------------------+
//|  Custom indicator iteration function                                       |
//+----------------------------------------------------------------------------+
void start() {
  double offSet=(WindowPriceMax()-WindowPriceMin())/100*5;
  double ms[2];
  int    LoopBegin, sh;

 	if (NumberOfBars==0) LoopBegin=Bars-50;
  else LoopBegin=NumberOfBars;
  LoopBegin=MathMin(Bars-50, LoopBegin);

  for (sh=LoopBegin; sh>=0; sh--) {
    ArrayInitialize(ms, EMPTY_VALUE);
    GetTradeSignals(ms, "", 0, sh);
    dBuf0[sh]=ms[0];
    dBuf1[sh]=ms[1];
    if (dBuf0[sh]!=EMPTY_VALUE) dBuf0[sh]-=offSet;
    if (dBuf1[sh]!=EMPTY_VALUE) dBuf1[sh]+=offSet;
  }
}

//+----------------------------------------------------------------------------+
//|                                         |
//|  :                                                                |
//|    ms -                                              |
//|    sy -     (""  NULL -  )          |
//|    tf -                   (    0       -  )       |
//|    nb -                   (    0       -  )             |
//+----------------------------------------------------------------------------+
void GetTradeSignals(double& ms[], string sy="", int tf=0, int nb=0) {
  if (sy=="" || sy=="0") sy=Symbol();
  double ma1=iMA(sy, tf, MA1.Period, 0, MA1.Method, MA1.APrice, nb+1);
  double ma2=iMA(sy, tf, MA2.Period, 0, MA2.Method, MA2.APrice, nb+1);
  double st0=iStochastic(sy, tf, KPeriod, DPeriod, Slowing, Method, Price_Field, MODE_SIGNAL, nb+1);
  double st1=iStochastic(sy, tf, KPeriod, DPeriod, Slowing, Method, Price_Field, MODE_SIGNAL, nb+2);
  double st2=iStochastic(sy, tf, KPeriod, DPeriod, Slowing, Method, Price_Field, MODE_SIGNAL, nb+3);

  if (ma1<ma2 && st2>=st1 && st1<st0) ms[0]=Low[nb];
  if (ma1>ma2 && st2<=st1 && st1>st0) ms[1]=High[nb];
}
//+----------------------------------------------------------------------------+

